﻿Imports ClassLibrary1.ParticleSample
Imports ClassLibrary1.ParticleSample.ParticleSystem
Imports Leap
Imports System.Windows.Ink


Partial Public Class MainWindow
    Private leap As New Controller
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint
    Private myParticle As New ClassLibrary1.ParticleSample.ParticleSystem(1000, Colors.White)

    Private windowWidth As Double = 1920
    Private windowHeight As Double = 1080

    Private tx As Double
    Private ty As Double
    Private x As Double
    Private y As Double

    Private no As Integer
    Private FingersCount As Integer

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        myParticle.pm = New ParticleSystemManager()
        myParticle.AddPaticle(WorldModels)

        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 20
        touchIndicator.Height = 20

        touchIndicator.StylusTip = StylusTip.Ellipse
    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox

        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)

            tx = normalizedPosition.x * windowWidth
            ty = windowHeight - normalizedPosition.y * windowHeight

            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            ''ホーバー
            'If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
            touchIndicator.Color = Colors.Blue
            FingersCount = leap.Frame.Fingers.Count

            If FingersCount = 1 OrElse FingersCount = 2 OrElse FingersCount = 3 OrElse FingersCount = 4 OrElse FingersCount = 5 Then

                x = (touchPoint.X - 970) * 0.05
                y = (touchPoint.Y - 520) * 0.05

                myParticle.ParticlePosition(x, y)
            End If
            'タッチ対象外
            'Else
            'touchIndicator.Color = Colors.Gold

            'End If
        Next
    End Sub

 
End Class


